/*ELECTRONOOBS CONSTANT LOAD 19/04/2020
* Scheamtic: https://electronoobs.com/eng_circuitos_tut50_sch1.php
* Tutorial: https://electronoobs.com/eng_circuitos_tut50.php
* Video: https://youtu.be/88xuhR30-dY
*/


#include <Wire.h>
#include <LiquidCrystal_I2C.h>      //Download it here: https://www.electronoobs.com/eng_arduino_liq_crystal.php
/////////////////////////////Library for ADS1115 ADC//////////////////////////////////
#include <Adafruit_ADS1015.h>       //Download here: https://www.electronoobs.com/eng_arduino_Adafruit_ADS1015.php
Adafruit_ADS1115 ads(0x48);         //Define i2c address 
//////////////////////////////////////////////////////////////////////////////////////


// Sometimes the address is 0x27 or 0x3f (try both)
LiquidCrystal_I2C lcd(0x27, 16, 2); //Address, columns, rows

const float multiplier = 0.0001875; //In order to pass from 16bits to real value voltage
int Buzzer = 3;                     //Pin for a buzzer (not yet used)
float offset = 0.004;               //Constant offset (in A) that the read has (yours might be different)


void setup() {
  Serial.begin(9600);

  pinMode(Buzzer,OUTPUT);
  digitalWrite(Buzzer,LOW);
  
  ads.begin();
  delay(10);
  
  lcd.init();
  lcd.backlight();
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("  ELECTRONOOBS  ");
  analogWrite(Buzzer,200);
  delay(100);
  analogWrite(Buzzer,LOW);
  delay(300);
  lcd.setCursor(0,1);
  lcd.print(" CONSTANT  LOAD ");
  delay(1500);
}

void loop() {
  float set_val, real_val;  
  real_val = ads.readADC_Differential_0_1();      //Read DIFFERENTIAL voltage between ADC0 and ADC1
  set_val  = ads.readADC_SingleEnded(2);          //Read voltage on potentiometer (this will be our setpoint)

  set_val = (set_val * multiplier) - offset;      //Pass to real voltage and substract offset
  real_val = real_val * multiplier - offset;

  //If we have negative value, we stay at 0. 
  if(real_val < 0)
  { real_val = 0;   }
  if(set_val < 0)
  { set_val  = 0;   }

  //Print data on LCD
  //lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Set:     ");  
  lcd.print(set_val,3);
  lcd.print(" A"); 
  lcd.setCursor(0,1);
  lcd.print("Current: "); 
  lcd.print(real_val,3);
  lcd.print(" A"); 
  delay(100);                                       //Small delay
}
